package org.processmining.datapetrinets.datadiscovery;

import java.util.Map;
import java.util.Set;

import org.processmining.models.FunctionEstimator.DecisionTreeBasedFunctionEstimator;
import org.processmining.models.FunctionEstimator.OverlappingEstimatorGlobalDecisionTree;
import org.processmining.models.FunctionEstimator.Type;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class OverlappingGlobalDecisionTreesImpl extends AbstractDecisionRuleDiscovery {

	public OverlappingGlobalDecisionTreesImpl(DecisionTreeConfig config, Iterable<ProjectedTrace> projectedLog, int numInstancesEstimate) {
		super(config, projectedLog, numInstancesEstimate);
	}

	public OverlappingGlobalDecisionTreesImpl(DecisionTreeConfig config, Iterable<ProjectedTrace> projectedLog,
			Map<String, Type> attributeType, Map<String, Set<String>> literalValues, int numInstancesEstimate) {
		super(config, projectedLog, attributeType, literalValues, numInstancesEstimate);
	}

	public DecisionRule discoverRulesForPlace(PetrinetGraph net, Place place) throws RuleDiscoveryException {

		Set<Transition> transitions = getTransitionPostset(net, place);

		DecisionTreeBasedFunctionEstimator estimator = new OverlappingEstimatorGlobalDecisionTree(attributeType, literalValues,
				transitions.toArray(), getNumInstanceEstimate(), place.getLabel());

		return doDiscoverDecisionTree(place, transitions, estimator);
	}


}
