package org.processmining.datapetrinets.datadiscovery;

import java.util.Map;
import java.util.Set;

import org.processmining.models.FunctionEstimator.OverlappingEstimatorLocalDecisionTree;
import org.processmining.models.FunctionEstimator.Type;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class OverlappingLocalDecisionTreesImpl extends AbstractDecisionRuleDiscovery {

	private boolean isReduceMinLeafs = true;

	public OverlappingLocalDecisionTreesImpl(DecisionTreeConfig config, Iterable<ProjectedTrace> projectedLog, int numInstancesEstimate) {
		super(config, projectedLog, numInstancesEstimate);
	}

	public OverlappingLocalDecisionTreesImpl(DecisionTreeConfig config, Iterable<ProjectedTrace> projectedLog,
			Map<String, Type> attributeType, Map<String, Set<String>> literalValues, int numInstancesEstimate) {
		super(config, projectedLog, attributeType, literalValues, numInstancesEstimate);
	}

	public DecisionRule discoverRulesForPlace(PetrinetGraph net, Place place) throws RuleDiscoveryException {

		Set<Transition> transitions = getTransitionPostset(net, place);

		OverlappingEstimatorLocalDecisionTree estimator = new OverlappingEstimatorLocalDecisionTree(attributeType, literalValues,
				transitions.toArray(), getNumInstanceEstimate(), place.getLabel());
		estimator.setReduceMinLeafs(isReduceMinLeafs);
		
		return doDiscoverDecisionTree(place, transitions, estimator);
	}
	
	public boolean isReduceMinLeafs() {
		return isReduceMinLeafs;
	}

	public void setReduceMinLeafs(boolean isReduceMinLeafs) {
		this.isReduceMinLeafs = isReduceMinLeafs;
	}	

}
