package org.processmining.models.FunctionEstimator;

import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

import org.processmining.datapetrinets.expression.GuardExpression;
import org.processmining.datapetrinets.utils.WekaTreeClassificationAdapter.WekaLeafNode;
import org.processmining.framework.util.Pair;
import org.processmining.models.guards.Expression;

import com.google.common.base.Function;
import com.google.common.collect.Maps;
import com.google.common.collect.Maps.EntryTransformer;

@Deprecated
abstract public class AbstractFunctionEstimator implements FunctionEstimator {

	@Override
	public Map<Object, Pair<Expression, Double>> getEstimation(Object[] option) throws Exception {
		Map<Object, FunctionEstimation> functionEstimation = getFunctionEstimation(option);
		return convertToExpression(functionEstimation);
	}

	/**
	 * Bridge method that provides backwards compatibility
	 * 
	 * @param functionEstimation
	 * @return
	 */
	protected Map<Object, Pair<Expression, Double>> convertToExpression(
			Map<Object, FunctionEstimation> functionEstimation) {
		return Maps.transformEntries(functionEstimation,
				new EntryTransformer<Object, FunctionEstimation, Pair<Expression, Double>>() {

					public Pair<Expression, Double> transformEntry(Object key, FunctionEstimation value) {
						try {
							return new Pair<Expression, Double>(new Expression(value.getExpression()
									.toCanonicalString()), value.getQualityMeasure());
						} catch (ParseException e) {
							throw new RuntimeException(
									"Could not convert GuardExpression to old deprecated Expression!", e);
						}
					}

				});
	}

	/**
	 * Converts the supplied {@link WekaLeafNode}s to a {@link Map} of {@link FunctionEstimation}s.
	 * 
	 * @param wekaLeafsNodes
	 * @param classMapping
	 * @param evaluation 
	 * @return
	 * @throws org.processmining.datapetrinets.expression.syntax.ParseException
	 */
	protected static Map<Object, FunctionEstimation> buildExpressionsFromLeafs(Iterable<WekaLeafNode> wekaLeafsNodes,
			Function<String, Object> classMapping) throws org.processmining.datapetrinets.expression.syntax.ParseException {
		Map<Object, FunctionEstimation> expressionEstimation = new HashMap<>();
		for (WekaLeafNode leaf : wekaLeafsNodes) {
			if (leaf.getInstanceCount() > 0.0) {
				Object leafClass = classMapping.apply(leaf.getClassName());
				FunctionEstimation existingCondition = expressionEstimation.get(leafClass);
				if (existingCondition != null) {
					GuardExpression newCondition = GuardExpression.Operation.or(existingCondition.getExpression(),
							leaf.getExpression());
					expressionEstimation.put(leafClass, FunctionEstimation.Factory.create(newCondition, -1d));
				} else {
					GuardExpression expression = leaf.getExpression();
					if (expression != null) {
						expressionEstimation.put(leafClass, FunctionEstimation.Factory.create(expression, -1d));
					}
				}				
			}
		}
		
		return expressionEstimation;
	}

}
